# sed
SED command in UNIX stands for stream editor and it can perform lots of functions on file like searching, find and replace, insertion or deletion. Though most common use of SED command in UNIX is for substitution or for find and replace. By using SED you can edit files even without opening them, which is much quicker way to find and replace something in file, than first opening that file in VI Editor and then changing it.

SED is a powerful text stream editor. Can do insertion, deletion, search and replace(substitution).
SED command in unix supports regular expression which allows it perform complex pattern matching.

# Syntax
`sed OPTIONS... [SCRIPT] [INPUTFILE...] `

# Examples
### Replacing or substituting string
Sed command is mostly used to replace the text in a file. The below simple sed command replaces the word “unix” with “linux” in the file.

`sed 's/unix/linux/' example.txt`

### Replacing the nth occurrence of a pattern in a line 
Use the /1, /2 etc flags to replace the first, second occurrence of a pattern in a line. The below command replaces the second occurrence of the word “unix” with “linux” in a line.

`sed 's/unix/linux/2' example.txt`


### Replacing all the occurrence of the pattern in a line
The substitute flag /g (global replacement) specifies the sed command to replace all the occurrences of the string in the line.

`sed 's/unix/linux/g' example.txt`

### Replacing from nth occurrence to all occurrences in a line
Use the combination of /1, /2 etc and /g to replace all the patterns from the nth occurrence of a pattern in a line. The following sed command replaces the third, fourth, fifth… “unix” word with “linux” word in a line.

`$sed 's/unix/linux/3g' example.txt`

### Parenthesize first character of each word
This sed example prints the first character of every word in parenthesis.
`echo "Welcome To The Geek Stuff" | sed 's/\(\b[A-Z]\)/\(\1\)/g'`

### Replacing string on a specific line number
You can restrict the sed command to replace the string on a specific line number.

`sed '3 s/unix/linux/' example.txt`

### Duplicating the replaced line with /p flag
The /p print flag prints the replaced line twice on the terminal. If a line does not have the search pattern and is not replaced, then the /p prints that line only once.

`sed 's/unix/linux/p' example.txt`

### Printing only the replaced lines 
Use the -n option along with the /p print flag to display only the replaced lines. Here the -n option suppresses the duplicate rows generated by the /p flag and prints the replaced lines only one time.

`sed -n 's/unix/linux/p' example.txt`

### Replacing string on a range of lines
You can specify a range of line numbers to the sed command for replacing a string.
`sed '1,3 s/unix/linux/' example.txt`

### Deleting lines from a particular file
SED command can also be used for deleting lines from a particular file. SED command is used for performing deletion operation without even opening the file

`sed 'nd' filename.txt`

To delete a fifth line:

`sed '5d' filename.txt`

To delete the last line:

`sed '$d' filename.txt`

To delete line from range x to y:

`sed '3,6d' filename.txt`

To delete from nth to last line:

`sed '12,$d' filename.txt`
 
To Delete pattern matching line:

`sed '/abc/d' filename.txt`
